package net.sourceforge.amore.gui.Actions ;

import net.sourceforge.amore.Ldo.LangDefObj ;

import javax.swing.AbstractAction ;

/** subclasses of this class hold action objects, which all represent
 *  an arrow (a function). the source of the arrow can be set (an argument
 *  to the function), which will lead some action objects to be disabled,
 *  if the argument is not of the correct type. Thus, it is ensured that
 *  the user may only call valid commands.
 *  <p>
 *  see TransUnaryA for examples.
 */
public abstract class Arrows {

    /** containts the source LangDefObj */
    protected static LangDefObj source;

    /** TMPTMPTMP
     */
    protected void toggleActions( AbstractAction[] ac, boolean b ) {
	for (int i=0; i<ac.length; i++) {
	    ac[i].setEnabled( b );
	}
    }

    /** sets the source of the binary transformation to the
     *  argument and calls toggleActions() afterwards.
     *  @param ldo the new source (may be null)
     */
    final public void setSource(LangDefObj ldo) {
        source = ldo;
        toggleActions();
    };
 
    /** this method is implemented in subclasses according to the
     *  conditions it imposes on its Arrows. toggles actions on or
     *  off, depending on type of source.  source may be null.
     */
    protected abstract void toggleActions() ;

    public abstract AbstractAction[] getAllActions();
}
