package net.sourceforge.amore.gui ;

import net.sourceforge.amore.gui.global.Resource ;
import net.sourceforge.amore.gui.SessionTree.GuiNode.* ;
import net.sourceforge.amore.gui.SessionTree.SessionTree ;
import net.sourceforge.amore.gui.Panels.RootPanel ;


import java.awt.*;
import java.awt.event.*;
import javax.swing.JPanel ;
import javax.swing.JSplitPane ;
import javax.swing.JScrollPane ;
import javax.swing.JTree ;

import java.util.Iterator;

import javax.swing.tree.* ;

import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.tree.TreeSelectionModel;

import java.lang.Exception ;

/** main display component. remembers current and last selected ldo and Panels
 */

class AmoreSplitPane extends JSplitPane {

    static SessionTree sessionTree;
    static JScrollPane scrollpane;
    static JScrollPane rightPane;

    public void setRightPanel( Component comp ) {
	// comp.validate();
	rightPane.setViewportView( comp );
	setRightComponent(rightPane);
    }

    public void updateRight() {
         GuiNode n = (GuiNode) sessionTree.getCurrent();
         setRightPanel( n.getPanel() );
    }
    
    private static AmoreSplitPane instance;

    public static AmoreSplitPane createInstance(SessionTree sT) {
	if( instance != null )
	   throw new RuntimeException("attempt to initialize me twice!"); 
	instance = new AmoreSplitPane(sT);
	return instance;
    }

    public static AmoreSplitPane getInstance() {
	if( (Object) instance==null )
	    throw new RuntimeException("not properly initialized!");
	return instance;
    }

    private AmoreSplitPane( SessionTree sTree )  {
	super( JSplitPane.HORIZONTAL_SPLIT );
	// left component gets all extra space
	setResizeWeight( 0.3 );
	setOneTouchExpandable( true );
	sessionTree = sTree;
	
	final SessionTree sT = sessionTree;
	// update right panel on selecting something
	final AmoreSplitPane sPane = this;
	sessionTree.addTreeSelectionListener(new TreeSelectionListener() {
		public void valueChanged(TreeSelectionEvent e) {
		    GuiNode node = (GuiNode) sT.getLastSelectedPathComponent();
		    if (node == null) {
			System.out.println("SplitPane: null selected ??? ");
			return; // ignore
		    }
		    sPane.setRightPanel( node.getPanel() );
		}
	    }); //sessionTree.addTreeSel...
	
	
	scrollpane = new JScrollPane();
	scrollpane.setViewportView( sessionTree );

	rightPane = new JScrollPane();

	setLeftComponent(scrollpane);
	setRightComponent(rightPane);
    }
}
