package net.sourceforge.amore.gui.Dialogs ;

import java.beans.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.* ;

public  class FreshNameDialog extends JDialog {

    private static String typedText = null;
    private JOptionPane optionPane;

    public static String showDialog(JComponent comp, String s) {
	Frame frame = JOptionPane.getFrameForComponent(comp);
	FreshNameDialog dlg = new FreshNameDialog(frame, s);
	System.out.println("FreshNameDialog.showDialog called with "+s);

	dlg.setLocationRelativeTo(comp);
	dlg.setVisible(true);
	//System.out.println("in EDT? "+SwingUtilities.isEventDispatchThread());
	return typedText;
    }

    public String getFreshName() {
	return typedText;
    }

    private FreshNameDialog(Frame aFrame, String s /*, ActionListener a */) {
	super(aFrame, "name collision", true);

	final String msg1 = "There is already an object named";
	final String msg2 =  "\"" + s + "\" in this session.";
	final String msg3 = "Please enter a fresh name.";
	
	final JTextField textField = new JTextField(10);
	Object[] array = {msg1, msg2, msg3, textField};
	
	final String btnString1 = "Enter";
	final String btnString2 = "Cancel";
	Object[] options = {btnString1, btnString2};
	
	optionPane = new JOptionPane(array, 
				     JOptionPane.QUESTION_MESSAGE,
				     JOptionPane.YES_NO_OPTION,
				     null,
				     options,
				     options[0]);
	setContentPane(optionPane);
	setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
	addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent we) {
		    /*
		     * Instead of directly closing the window,
		     * we're going to change the JOptionPane's
		     * value property.
		     */
		    optionPane.setValue(new Integer(
						    JOptionPane.CLOSED_OPTION));
		}
	    });
	textField.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    optionPane.setValue(btnString1);
		}
	    });
	optionPane.addPropertyChangeListener(new PropertyChangeListener() {
		public void propertyChange(PropertyChangeEvent e) {
		    String prop = e.getPropertyName();
		    
		    if (isVisible() 
			&& (e.getSource() == optionPane)
			&& (prop.equals(JOptionPane.VALUE_PROPERTY) ||
			    prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
			Object value = optionPane.getValue();
			
			if (value == JOptionPane.UNINITIALIZED_VALUE) {
				//ignore reset
			    return;
			}
			
			// Reset the JOptionPane's value.
			// If you don't do this, then if the user
			// presses the same button next time, no
			// property change event will be fired.
			optionPane.setValue( JOptionPane.UNINITIALIZED_VALUE );
			
			if (value.equals(btnString1)) {
			    typedText = textField.getText();
			    
				// set the name to the new name
			    if(typedText != "" & false /* FIXME AmoreSession.getInstance().isFreshName( typedText ) */) {
				System.out.println("user typed:"+typedText + " are we in EDT? " + SwingUtilities.isEventDispatchThread() );
				
				setVisible(false);
			    } else {
				// text was invalid again
				textField.selectAll();
				JOptionPane.showMessageDialog(FreshNameDialog.this,
							      "Please enter a name that is \n"+
							      "not already present in this session!",
							      "Try again",
							      
							      JOptionPane.ERROR_MESSAGE);
				typedText = null;
				System.out.println("INVALID AGAIN");
			    }
			} else { 
				// user closed dialog or clicked cancel
				// status line!!
			    System.out.println("CANCEL PRESSED ?");
			    typedText = null;
			    setVisible(false);
			}
		    }
		}
	    }); // new PropertyChangeListener
	pack();
    } // public FreshName.. 
    
} // class FreshN..
