package net.sourceforge.amore.gui.EditPanels.Fields ;

import net.sourceforge.amore.gui.AmoreFrame; // gimmick

import net.sourceforge.amore.gui.util.QTool ;
import javax.swing.*; 
import javax.swing.text.*; 

import java.awt.Toolkit;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Locale;
import java.util.Vector;
import java.io.IOException ;
/** JTextField for editing nfa transition targets.
 *  a close relative to util.WholeNumberField.
 */

public class RegExpField extends JTextField {
    private Toolkit toolkit;
    private NumberFormat integerFormatter;
    private int qStart;
  
    private int max;
    
    /* works only in jdk >= 1.3
       class MyInputVerifier extends InputVerifier {
       public boolean verify(JComponent input) {
       RegExpField tf = (RegExpField) input;
       int target = tf.getValue();
       return (target<getMax());
       }
       }
    */ 
    public RegExpField(Vector value, int columns, int max) {
        super(columns);
	// see above
	// setInputVerifier( new MyInputVerifier() );
	this.max = max;
	qStart = 0;
        toolkit = Toolkit.getDefaultToolkit();
        integerFormatter = NumberFormat.getNumberInstance(Locale.US);
        integerFormatter.setParseIntegerOnly(true);
        if( value != null ) setValue(value);
    }

  public int getMax() {
    return max;
  }

    public void setMax(int max) {
	this.max = max;
    }
    
    /** throws an IllegalArgumentException if string is not in nfa format
     */
    public Vector getValue() {
        Vector retVal = null;
	
	String s = getText();
	/*
	  if( s.endsWith("]") ) {
	  s = s.substring(0, s.length()-1);
	  }
	  s = s.substring(qStart);
	*/
	
	// retVal = integerFormatter.parse(s).intValue();
	retVal = QTool.nfaParse( s );
	/* catch (ParseException e) {
	   // This should never happen because insertString allows
	   // only properly formatted data to get in the field.
	   toolkit.beep();
	   } */
        return retVal;
    }
    
    public void setValue(Vector value) {
        setText( value.toString() );
    }

    protected Document createDefaultModel() {
        return new RegExpDocument();
    }

    // test whether string is a valid regexp
    // test whether it is regular or generalized regular
    
    protected class RegExpDocument extends PlainDocument {

	// JDK calls insertString ...
	// - when editing of the cell starts (offs 0, str=whole input)
	// - after each key press
	
        public void insertString(int offs, 
                                 String str,
                                 AttributeSet a) 
	    throws BadLocationException {
	    
	    int    strLen = str.length();
	    int    bufferLen = getLength();
	    String buffer    = getText( 0, bufferLen );
	    System.out.println("buffer:\""+ buffer +"\"");
	    
	    int    resLen = bufferLen + strLen;
	    char[] res = new char[ resLen ];
	    buffer.getChars(0, bufferLen, res, 0);
	    str.getChars(0, strLen, res, offs);
	    String r = new String(res, 0, resLen);
	    System.out.println(" res: " + r);

	    // DEBUG parse result
	    try{
		System.out.print("parsing -");
		//RegExp.parse(r);
		System.out.println("ok");
		AmoreFrame.setStatusText("ok");                 // gimmick
	    } catch (IllegalArgumentException e) {
		System.out.println(" NOT ok ");
		AmoreFrame.setStatusText("input is NOT valid"); // gimmick
	    }

	    super.remove(0, bufferLen);
	    super.insertString(0, r, a);
	}
    }
}
