/* MutableDfaPanel.java
 */

package net.sourceforge.amore.gui.EditPanels ;

import net.sourceforge.amore.gui.EditPanels.Tables.* ;
import net.sourceforge.amore.gui.util.LayoutHelp;
import net.sourceforge.amore.MutableLdo.MutableDfa ;
import net.sourceforge.amore.Ldo.* ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.table.* ;

public class MutableDfaPanel extends LdoEditPanel {
    
    final MutableDfa mdfa;

    JTable table;
    JLabel qnoLabel;

    /*
    public void cancel() {
	cancelled = true;
    }
    */

    /*
    public void updateLdo() {
	//System.out.println( nameField.getText() );
	//mdfa.setName( nameField.getText() );
	// nothing to do, since ldo gets updated after each edit
	//System.out.println( mdfa.getName() );
	
    }
    */

    public boolean ldoValid() {
	return mdfa.isValid();
    }

    public LangDefObj getLdo() {
	//if( !cancelled )
	return mdfa.toDfa();
	//else 
	//return null;
    };

    public void addLetter() {
        mdfa.addLetter();
        table.setModel(new MutableDfaTableModel(mdfa));
    }
    
    public void remLetter() {
        mdfa.removeLetter();
        table.setModel(new MutableDfaTableModel(mdfa));
    }
    
    public MutableDfaPanel( MutableDfa m ) {
	super();
	constraints.gridy = 0;
	makeTitle("creating Dfa");
        this.mdfa = m;

	this.table = new MutableDfaTable( new MutableDfaTableModel( mdfa ) );
	JTableHeader tableHeader = table.getTableHeader();

	constraints.gridwidth = 1;
	constraints.weightx = 1;	

	constraints.gridy++;
	constraints.gridx = 0;
	LayoutHelp.addSpacer(0,10,this,gridbag, constraints);
	constraints.gridwidth = 1;

	constraints.gridy++;
	constraints.gridx = 0;
	// number of states
	makeLabel("nstates: ");
	constraints.gridx++;
	constraints.gridwidth = 1;

	qnoLabel = new JLabel( Integer.toString( mdfa.getNstates() ));
	gridbag.setConstraints( qnoLabel, constraints );
	add( qnoLabel );
	// ----------------------------------------     add State Button
	JButton addS = new JButton("add state");
	addS.addActionListener( new AddStateActionListener(mdfa, qnoLabel, table) );
	constraints.gridwidth = GridBagConstraints.RELATIVE;
	constraints.gridx++;
	gridbag.setConstraints( addS, constraints );
	add( addS );
	// ----------------------------------------  remove State Button
	JButton remS = new JButton("rem.state");
	remS.addActionListener( new RemoveStateActionListener(mdfa, qnoLabel, table) );
	constraints.gridwidth = GridBagConstraints.REMAINDER;
	constraints.gridx++;
	gridbag.setConstraints( remS, constraints );
	add( remS );

	constraints.gridy++;
	constraints.gridx = 0;
	LayoutHelp.addSpacer(0,10,this,gridbag, constraints);

	// ------------------------------------------ table header and table
	constraints.gridy++;	
	constraints.gridx = GridBagConstraints.REMAINDER;
	constraints.gridwidth = GridBagConstraints.REMAINDER; //end row
	
	gridbag.setConstraints(tableHeader, constraints);
	add(tableHeader);
	
	constraints.gridy = GridBagConstraints.RELATIVE;	
	constraints.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(table, constraints);
	add(table);
    }

    public class AddStateActionListener implements ActionListener {
	MutableDfa mdfa;
	JLabel     qnoLabel;
	JTable     tab;
	public void actionPerformed(ActionEvent e) {
	    mdfa.addState();
	    qnoLabel.setText( Integer.toString( mdfa.getNstates() ));
	    tab.setModel(new MutableDfaTableModel(mdfa));
	    //System.out.println("add state pressed");
	}
	public AddStateActionListener(MutableDfa mdfa, 
				      JLabel qnoLabel, JTable tab) {
	    this.mdfa=mdfa;
	    this.qnoLabel=qnoLabel;
	    this.tab=tab;
	}
    }
    
    public class RemoveStateActionListener implements ActionListener {
	MutableDfa mdfa;
	JLabel     qnoLabel;
	JTable     tab;
	public void actionPerformed(ActionEvent e) {
	    mdfa.removeState();
	    qnoLabel.setText( Integer.toString( mdfa.getNstates() ));
	    tab.setModel(new MutableDfaTableModel(mdfa));
	}
	public RemoveStateActionListener(MutableDfa mdfa, 
					 JLabel qnoLabel, JTable tab) {
	    this.mdfa=mdfa;
	    this.qnoLabel=qnoLabel;
	    this.tab=tab;
	}
    }
}

