/* MutableNfaPanel.java
 */

package net.sourceforge.amore.gui.EditPanels ;

import net.sourceforge.amore.gui.EditPanels.Tables.* ;
import net.sourceforge.amore.gui.util.LayoutHelp;

import net.sourceforge.amore.MutableLdo.MutableNfa ;
import net.sourceforge.amore.Ldo.* ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.table.* ;

public class MutableNfaPanel extends LdoEditPanel {
    
    final MutableNfa mnfa;

    JTable table;
    JLabel qnoLabel;

    /*
    public void cancel() {
	System.out.println("cancel !");
	cancelled = true;
    }
    */

    /*
    public void updateLdo() {
	//System.out.println( nameField.getText() );
	//mnfa.setName( nameField.getText() );
	// nothing to do, since ldo gets updated after each edit
	//System.out.println( mnfa.getName() );
	
    }
    */

    public boolean ldoValid() {
	return mnfa.isValid();
    }

    public LangDefObj getLdo() {
	//if( !cancelled )
	return mnfa.toNfa();
	//else 
	//return null;
    };
    
    public void addLetter() {
        mnfa.addLetter();
        table.setModel(new MutableNfaTableModel(mnfa));
    }
    
    public void remLetter() {
        mnfa.removeLetter();
        table.setModel(new MutableNfaTableModel(mnfa));
    }

    public MutableNfaPanel( MutableNfa m ) {
	super();
	constraints.gridy = 0;
	makeTitle("creating Nfa");
        this.mnfa = m;

	this.table = new MutableNfaTable( new MutableNfaTableModel( mnfa ) );
	JTableHeader tableHeader = table.getTableHeader();

	constraints.gridwidth = 1;
	constraints.weightx = 1;

	constraints.gridy++;
	constraints.gridx = 0;
	LayoutHelp.addSpacer(0,10,this,gridbag, constraints);
	constraints.gridwidth = 1;

	constraints.gridy++;
	constraints.gridx = 0;
	// number of states
	makeLabel("nstates: ");
	constraints.gridx++;
	constraints.gridwidth = 1;
	
	qnoLabel = new JLabel( Integer.toString( mnfa.getNstates() ));
	gridbag.setConstraints( qnoLabel, constraints );
	add( qnoLabel );
	//constraints.gridwidth = 1;

	// ----------------------------------------     add State Button
	JButton addS = new JButton("add state");
	addS.addActionListener( new AddStateActionListener(mnfa, qnoLabel, table) );
	constraints.gridwidth = GridBagConstraints.RELATIVE;
	constraints.gridx++;
	gridbag.setConstraints( addS, constraints );
	add( addS );

	// ----------------------------------------  remove State Button

	JButton remS = new JButton("rem state");
	remS.addActionListener(new RemoveStateActionListener(mnfa, qnoLabel, table));
	constraints.gridwidth = GridBagConstraints.REMAINDER;
	constraints.gridx++;
	gridbag.setConstraints( remS, constraints );
	add( remS );
	
	constraints.gridy++;
	constraints.gridx = 0;
	LayoutHelp.addSpacer(0,10,this,gridbag, constraints);

	// ------------------------------------------ table header and table
	constraints.gridy++;	
	constraints.gridx = GridBagConstraints.REMAINDER;
	constraints.gridwidth = GridBagConstraints.REMAINDER; //end row


	gridbag.setConstraints(tableHeader, constraints);
	add(tableHeader);
	constraints.gridy = GridBagConstraints.RELATIVE;	
	constraints.gridwidth = GridBagConstraints.REMAINDER;

	gridbag.setConstraints(table, constraints);
	add(table);
    }

    public class AddStateActionListener implements ActionListener {
	MutableNfa mnfa;
	JLabel     qnoLabel;
	JTable     tab;
	public void actionPerformed(ActionEvent e) {
	    mnfa.addState();
	    qnoLabel.setText( Integer.toString( mnfa.getNstates() ));
	    tab.setModel(new MutableNfaTableModel(mnfa));
	    //System.out.println("add state pressed");
	}
	public AddStateActionListener(MutableNfa mnfa, 
				      JLabel qnoLabel, JTable tab) {
	    this.mnfa=mnfa;
	    this.qnoLabel=qnoLabel;
	    this.tab=tab;
	}
    }

    public class RemoveStateActionListener implements ActionListener {
	MutableNfa mnfa;
	JLabel     qnoLabel;
	JTable     tab;
	public void actionPerformed(ActionEvent e) {
	    mnfa.removeState();
	    qnoLabel.setText( Integer.toString( mnfa.getNstates() ));
	    tab.setModel(new MutableNfaTableModel(mnfa));
	}
	public RemoveStateActionListener(MutableNfa mnfa, 
				      JLabel qnoLabel, JTable tab) {
	    this.mnfa=mnfa;
	    this.qnoLabel=qnoLabel;
	    this.tab=tab;
	}
    }

}

