/* RegExpEditPanel.java
 */

package net.sourceforge.amore.gui.EditPanels ;

import net.sourceforge.amore.gui.util.LayoutHelp;
import net.sourceforge.amore.Ldo.LangDefObj ;
import net.sourceforge.amore.Ldo.RegExp ;
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;

public class RegExpEditPanel extends LdoEditPanel  {
    
    JTextField rexEditField;
    JLabel error;
    RegExp rex;
    int sno;

    /**  returns true if regexp is valid
     */ 
    public boolean ldoValid() {
	String err = RegExp.testparse(rexEditField.getText(), sno);
	if( err != null )
	    return true;
	System.err.println("RegExpEditPanel.ldoValid: "+err);
	return false;
    }
    
    /** returns the regexp
     */
    public LangDefObj getLdo() {
	String err = RegExp.testparse(rexEditField.getText(), sno);
	if( err == null )
	    return new RegExp(rexEditField.getText(), sno);
	else {
	    System.out.println(err);
	    error.setText( err );
	}
	return null;
    }

    public void addLetter() {
        rex.setNletters( rex.getNletters() + 1 );
    }
    public void remLetter() {
        int i = rex.getNletters();
        if( i>1 )
            rex.setNletters( i - 1 );
    }
    
    public RegExpEditPanel( RegExp rex ) {
	super();
	sno = rex.getNletters();
	constraints.gridy = 0;
	makeTitle("editing RegExp");
        this.rex = rex;
	constraints.gridy++;
	constraints.gridx = 0;
	LayoutHelp.addSpacer(0,10,this,gridbag, constraints);
	constraints.gridwidth = 1;
	
	constraints.gridy++;
	constraints.gridx = 0;
	constraints.gridwidth = GridBagConstraints.REMAINDER ;
	rexEditField = new JTextField( 20 );
	rexEditField.setText( rex.getRex() );

	gridbag.setConstraints( rexEditField, constraints );
	add( rexEditField );
	
	error = new JLabel("");
	add( error );

}

    
}
