package net.sourceforge.amore.gui.EditPanels.Tables ;

import net.sourceforge.amore.MutableLdo.MutableDfa ;

import net.sourceforge.amore.gui.EditPanels.Fields.DfaTransitionField ;
import java.awt.* ;
import javax.swing.* ;
import javax.swing.table.* ;



/** Table that displays transition table of a MutableDfa
 */
public class MutableDfaTable extends JTable {

  final DfaTransitionField dfaTField;

  public void setModel( MutableDfaTableModel tm ){
      super.setModel( tm );
      dfaTField.setMax( getRowCount()-1 );
  }

  public MutableDfaTable( MutableDfaTableModel tm ) {
	super( tm );
	setRowSelectionAllowed( false );
	getTableHeader().setReorderingAllowed( false );

	// get first column, 
	TableColumnModel colmodel = getColumnModel();
	TableColumn col1 = colmodel.getColumn( 0 );
	// make it gray
	DefaultTableCellRenderer renderer = new DefaultTableCellRenderer();
	renderer.setBackground(new Color(215,215,215));
	col1.setCellRenderer( renderer );
       
	// set editor for transitions
	int m = getRowCount()-1; // number of states;
	dfaTField = new DfaTransitionField(0, 5, m);
	dfaTField.setHorizontalAlignment(DfaTransitionField.RIGHT);

	final DfaTransitionField df = dfaTField;
	DefaultCellEditor dfaTEditor = 
	    new DefaultCellEditor(df) {
		    //Override DefaultCellEditor's getCellEditorValue method
		    //to return an Integer, not a String:
		    public Object getCellEditorValue() {
			return new Integer(dfaTField.getValue());
		    }
		    // tablemodel.setValue method will deal with this integer
		};
	
	// all targets of transitions are strings.
	setDefaultEditor(String.class,  dfaTEditor);

    }
}
