package net.sourceforge.amore.gui.EditPanels.Tables ;

import net.sourceforge.amore.MutableLdo.MutableNfa ;
// import net.sourceforge.amore.gui.util.QTool ;
import net.sourceforge.amore.gui.EditPanels.Fields.NfaTransitionField ;
import java.awt.* ;
import javax.swing.* ;
import javax.swing.table.* ;



/** Table that displays transition table of a MutableNfa
 */
public class MutableNfaTable extends JTable {

  final NfaTransitionField nfaTField;

  public void setModel( MutableNfaTableModel tm ){
      super.setModel( tm );
      nfaTField.setMax( getRowCount()-1 );
  }

  public MutableNfaTable( MutableNfaTableModel tm ) {
	super( tm );
	setRowSelectionAllowed( false );
	getTableHeader().setReorderingAllowed( false );

	// get first column, 
	TableColumnModel colmodel = getColumnModel();
	TableColumn col1 = colmodel.getColumn( 0 );
	// make it gray
	DefaultTableCellRenderer renderer = new DefaultTableCellRenderer();
	renderer.setBackground(new Color(215,215,215));
	col1.setCellRenderer( renderer );
       
	// set editor for transitions
	int m = getRowCount()-1; // number of states;
	nfaTField = new NfaTransitionField(null, 5, m);
	nfaTField.setHorizontalAlignment(NfaTransitionField.RIGHT);

	final NfaTransitionField df = nfaTField;
	DefaultCellEditor nfaTEditor = 
	    new DefaultCellEditor(df) {
		    //Override DefaultCellEditor's getCellEditorValue method
		    //to return a Vector of Int not a String:
		    public Object getCellEditorValue() {
			return nfaTField.getValue();
		    }
		    // tablemodel.setValue method will deal with this integer
		};
	
	// all targets of transitions are strings.
	setDefaultEditor(String.class,  nfaTEditor);

    }
}
