/* Main.java
 *
 * Burak Emir
 */

package net.sourceforge.amore.gui ;

import net.sourceforge.amore.gui.global.* ;
import net.sourceforge.amore.gui.SessionTree.SessionTree ;
import net.sourceforge.amore.gui.util.StartupWindow ;

import net.sourceforge.amore.InitLibAMoRE ;
import net.sourceforge.amore.Ldo.* ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;

/** the Main class. shows a splash window and creates the AmoreFrame
 * (the application frame). To do: handling command line arguments.
 */

public class Main {

    /** the AmoreFrame */
    static JFrame       frame ;

    /** initial height of the AmoreFrame */
    final static int frameHeight = 500;

    /** initial width of the AmoreFrame */
    final static int frameWidth = 500;

    /** starts AMoREgui
     */
    public static void main( String args[] ) {
        /** the current session */
	SessionTree session;

	if( args.length == 0 ) {
            
	    // create new session (here: test session)
	    session = SessionTree.createInstance();
	    frame = AmoreFrame.createInstance(session);
	} else {

	    // load saved session ? TO DO
	    System.out.println("I don't accept arguments yet.");
	    System.exit( -1 ); // FIXME
	}
	
        // show startup screen in the middle of the screen
	GraphicsConfiguration gc = GraphicsEnvironment
            .getLocalGraphicsEnvironment()
            .getDefaultScreenDevice()
            .getDefaultConfiguration();
	Rectangle r = gc.getBounds();

	frame.setSize( frameHeight, frameWidth );
	int x = (r.width - frameWidth) / 2;
	int y = (r.height - frameHeight) / 2;
	frame.setBounds(x,y, frameWidth,frameHeight);


	StartupWindow.showWin = false;
	frame.setVisible(true);
		
    }

    static { // to do: command line option for verbosity...
	// display startup screen
	//StartupWindow.showStartupWindow();
	// DISABLED DOES NOT WORK ON SOME SYSTEMS BUGGY SUPERFLUOUS CRAP
	
	/* System.out.print("loading AMoRE-java library..."); */
        
        // load the AMoRE-J library
	System.loadLibrary("AMoRE-java");

	/* System.out.println("done"); */

	//System.out.print("  initializing ...");

        // initialise the library
	InitLibAMoRE.init();
    }
}
