/* LangDefObjPanel.java
 */

package net.sourceforge.amore.gui.Panels ;

import net.sourceforge.amore.gui.global.*;
import net.sourceforge.amore.gui.util.LayoutHelp;

import net.sourceforge.amore.Ldo.LangDefObj ;

import java.awt.* ;
import javax.swing.* ;

abstract public class LangDefObjPanel extends JPanel {

    protected static boolean DEBUG;

    protected GridBagConstraints constraints ;

    protected GridBagLayout gridbag ;

    protected void makeLabel(String s) {
	LayoutHelp.makeLabel(s, this, gridbag, constraints);
    }

    /** every LangDefObj has a title
     */
    protected void makeTitle( String s ) {
	JLabel label = new JLabel( s );
	label.setForeground(PanelUIResource.titleColor);
	label.setFont(PanelUIResource.titleFont);
	constraints.gridwidth = GridBagConstraints.REMAINDER; //end row
	gridbag.setConstraints( label, constraints );
	add( label );
    }

    public void addSpacer(int x, int y) {
	// S P A C E R
	// some space between table and other stuff
	Box spacer = Box.createVerticalBox();
	spacer.add( Box.createRigidArea( new Dimension( x, y )) );
	constraints.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(spacer, constraints);
	add( spacer );
    }

    private void init() {
	DEBUG = Resource.getInstance().getDebug();
	setFont( PanelUIResource.defaultFont );

	gridbag = new GridBagLayout();
	constraints = new GridBagConstraints() ;

	setLayout(gridbag);
    }

    public LangDefObjPanel( LangDefObj obj ) {
	init();
	//setPreferredSize(new Dimension(200, 200) );
	
	constraints.weightx = 1.0;
	// first comp should be title.
	constraints.fill = GridBagConstraints.NONE;

	makeTitle( obj.getFullName() );	

    }

    // this is not used inside THIS package, but in LdoEditPanel
    protected LangDefObjPanel() {
	init();
    }

}
