/** \file DfaTableModel.java
 */

package net.sourceforge.amore.gui.Panels.Tables ;

import net.sourceforge.amore.gui.util.QTool ;
import net.sourceforge.amore.Ldo.Dfa ;

import java.awt.* ;
import javax.swing.* ;
import javax.swing.table.* ;

import net.sourceforge.amore.Helper.ArrayFunc ;

public class DfaTableModel extends AbstractTableModel {
    Dfa dfa;

    public int getColumnCount() { 
	// nletters + 1 (first col = names)
	return dfa.getNletters() + 1;
    }
    public int getRowCount() { 
	return dfa.getNstates();
    }
    public Class getColumnClass(int i) {
	return String.class ;
    }
    public String getColumnName( int column ) {
	if(column == 0) 
	    return "";
	else
	    // 0 -> "eps", 1 -> "a", ...
	    return QTool.letters[ column ];
    }
    public Object getValueAt(int row, int col) {
	// System.out.println("DfaTableModel.getValueAt( "+row+", "+col+" )");
	if ( 0 == col ) { // first col. contains state-names 
	    return QTool.qQ(row, 
                            dfa.isInitState( row ), 
                            dfa.isFinalState( row ));
	} else {
	    // delta[ 0 ] unused ( libAMoRE compatibility )
	    int i =  dfa.getcon( row, col );
	    if( i!= ArrayFunc.UNDEF )
		return QTool.qQ( i, dfa.isFinalState( i ) );
	    else
		return "";
	}
    } // getValueAt

    public DfaTableModel( Dfa dfa ) {
	this.dfa = dfa;
    }
}
