/** NfaStatesTableModel.java
 */
package net.sourceforge.amore.gui.Panels.Tables ;

import net.sourceforge.amore.gui.util.QTool ;
import net.sourceforge.amore.Ldo.Nfa ;

import java.awt.* ;
import javax.swing.* ;
import javax.swing.table.* ;

public class NfaTableModel extends AbstractTableModel {

    Nfa nfa;

    public int getColumnCount() { 
	// nletters [ + 1 (eps) ] + 1 (since first col = names)
	if ( nfa.isEps() )
	    return nfa.getNletters() + 2;
	else
	    return nfa.getNletters() + 1;
    }
    public int getRowCount() { 
	return nfa.getNstates();
    }
    public Class getColumnClass() {
	return String.class ;
    }
    public String getColumnName( int column ) {
	if(column == 0)
	    // first col holds names
	    return "";
	else if ( nfa.isEps() ) {
	    // 0 -> "eps" 1 -> "a", ...
	    return QTool.letters[ column - 1 ];
	} else 
	    // 1 -> "a", 2 -> "b", ...
	    return QTool.letters[ column ];
    }

    public Object getValueAt(int row, int col) {
	if ( 0 == col ) { // first col. contains states
	    return QTool.qQ( row, 
			     nfa.isInitState( row ), 
			     nfa.isFinalState( row ) );

	} else {
	    if ( nfa.isEps() ) {
		// start with delta[ 0 ] for eps nfa
		col = col - 1;
	    }
	    // row = state, col = letter
	    return QTool.nfaQs( nfa.getcon( row, col ) );
	} // if col else
    } // getValue at

    public NfaTableModel( Nfa nfa ) {
	this.nfa = nfa;
    }
}
