package net.sourceforge.amore.gui.SessionTree.GuiNode ;

// import net.sourceforge.amore.gui.Panels.LdoWithPanel ;
import net.sourceforge.amore.Ldo.LangDefObj ;
import net.sourceforge.amore.gui.Panels.LangDefObjPanel ;
import net.sourceforge.amore.gui.Panels.PanelFactory;
import javax.swing.JPanel ;
import javax.swing.tree.* ;
import java.util.*;

/** is DefaultMutableTreeNode whose user object is a LdoWithPanel
 *  acts also as a Decorator for LdoWithPanel
 */
public class LwpNode extends GuiNode {

    RegLangSetNode parent;
    LangDefObj ldo;
    LangDefObjPanel lpan;

    public String toString() {
      if ( ldo.getRegSet().getInput() == ldo )
        return ldo.prefix() + " [inp]";
      else
        return ldo.prefix();
    }

    public LwpNode(RegLangSetNode parent, LangDefObj ldo) {
	this.ldo = ldo ;
	this.parent = parent;
	lpan = PanelFactory.createLdoPanel( ldo );
    }
    /** convenience method
     */
    public JPanel getPanel() {
	return lpan;
    }

    /** convenience method
     */
    public LangDefObj getLdo() {
	return ldo;
    }

    /** visitor method
     */
    public Object apply(GuiNodeVisitor v) {
	return v.caseLwpNode( this );
    }

    public TreePath getPath() {
	return parent.getPath().pathByAddingChild( this );
    }

    /////////////    // methods for TreeNode

    /** Returns the children of the reciever as an Enumeration. */
    public Enumeration children()       { return null; }

    /** Returns true if the receiver allows children. */
    public boolean getAllowsChildren()  {return false; }

    /** Returns the child TreeNode at index childIndex.*/
    public TreeNode getChildAt(int index)  {return null; }

    /** Returns the number of children TreeNodes the receiver contains. */
    public int getChildCount()              { return 0;}

    /** Returns the index of node in the receivers children.*/
    public int getIndex(TreeNode node) { return -1; }

    /** Returns the parent TreeNode of the receiver. */
    public TreeNode getParent() { return parent; }

    /** Returns true if the receiver is a leaf. */
    public boolean isLeaf() { return true; }



}
