package net.sourceforge.amore.gui.SessionTree.GuiNode ;

import net.sourceforge.amore.RegLangSet ;
import net.sourceforge.amore.RegLangSetObserver ;
import net.sourceforge.amore.Ldo.* ;
import net.sourceforge.amore.gui.Panels.RegLangSetPanel;

import javax.swing.JPanel ;

import javax.swing.tree.* ;
import java.util.* ;

/** contains a RegLangSet and its panel
 */
public class RegLangSetNode extends GuiNode implements RegLangSetObserver {
    
    RegLangSet rs;
    RegLangSetPanel rsp;

    // [GuiNode(RegExp), GuiNode(Nfa), GuiNode(Dfa)]
    Vector children = new Vector();
    // LwpNode children[] = new LwpNode[ 3 ]; 

    //int inputAt;

    /*
    static class IndexVisitor implements LangDefObjVisitor {
	public Object caseRegExp(RegExp r) { return new Integer(0); }
	public Object caseNfa(Nfa n)       { return new Integer(1); }
	public Object caseDfa(Dfa d)       { return new Integer(2); }
    };
    static IndexVisitor indexVisitor = new IndexVisitor();

    int indexOfClass(LangDefObj ldo) {
	return ((Integer) ldo.apply( indexVisitor )).intValue();
    }
    */
    public String toString() {
	return rs.getName();
    }

    public RegLangSetNode(RegLangSet rs) {
	this.rs =  rs;

        observers = new Vector();

        // register as observer
        rs.register( this );
        
	rsp = new RegLangSetPanel( rs );

	LangDefObj ldo = rs.getInput();
	LwpNode n = new LwpNode(this, ldo );
	//inputAt = indexOfClass( ldo );

	ldo = rs.getRegExp();
	if( ldo!=null ) children.add(new LwpNode( this, ldo ));
	ldo = rs.getNfa();
	if( ldo!=null ) children.add(new LwpNode( this, ldo ));
	ldo = rs.getDfa();
	if( ldo!=null ) children.add(new LwpNode( this, ldo ));
	ldo = rs.getMonoid();
	if( ldo!=null ) children.add(new LwpNode( this, ldo ));

    }
    
    public JPanel getPanel() {
	return rsp;
    }
    
    public RegLangSet getRegLangSet() {
	return rs;
    }

    /** this method is called by the ReglangSet this RegLangSetNode object
     *  holds, whenever an ldo was added. it creates an LwpNode, adds it to
     *  the children, and then notifies the objects that observe this 
     *  RegLangSetNode object, that an LwpNode was added
     */
    public void ldoAdded( LangDefObj ldo ) {
	LwpNode lwpNode = new LwpNode( this, ldo );
	children.add( lwpNode );
        notifyObservers( lwpNode );
    }

    // observer methods

    protected Vector observers;
    
    public void register( RegLangSetNodeObserver o ) {
        observers.add( o );
    }

    public void unregister( RegLangSetNodeObserver o ) {
        observers.remove( o );
    }

    protected void notifyObservers( LwpNode lwpNode ) {
        for(Iterator i = observers.iterator(); i.hasNext(); ){
            ((RegLangSetNodeObserver) i.next()).lwpNodeAdded( this, lwpNode );
        }
    }
    
    
    // may be null
    public LangDefObj getLdo( int index ) {
	return ((LwpNode) children.get( index )).getLdo();
    }
    
    public Object apply( GuiNodeVisitor v ) {
	return v.caseRegLangSetNode( this );
    }

    public TreePath getPath() {
	return RootNode.getInstance().getPath().pathByAddingChild( this );
    }

   /////////////    // methods for TreeNode

    /** Returns the children of the reciever as an Enumeration. */
    public Enumeration children() {
	return children.elements();
    }

    /** Returns true if the receiver allows children. */
    public boolean getAllowsChildren()  {return true; }

    /** Returns the child TreeNode at index childIndex.*/
    public TreeNode getChildAt(int index)  {
	return (TreeNode) children.get(index); 
    }

    /** Returns the number of children TreeNodes the receiver contains. */
    public int getChildCount()              {
	return children.size();
    }

    /** Returns the index of node in the receivers children.*/
    public int getIndex(TreeNode node) { 
	return children.indexOf( node );
    }

    /** Returns the parent TreeNode of the receiver. */
    public TreeNode getParent() { return RootNode.getInstance(); }

    /** Returns true if the receiver is a leaf. */
    public boolean isLeaf() { return false; }



}
