package net.sourceforge.amore.gui.SessionTree.GuiNode ;

import net.sourceforge.amore.gui.Panels.RootPanel ;

import net.sourceforge.amore.RegLangSet;
import net.sourceforge.amore.Ldo.LangDefObj ;

import javax.swing.JPanel ;
import javax.swing.tree.*;
import java.util.* ;

/** is DefaultMutableTreeNode whose user object is a LdoWithPanel
 */
public class RootNode extends GuiNode {

    String sessionName;

    static JPanel rootPanel;

    Vector rsVec = new Vector();

    public static RootNode createInstance(String s) {
	if( instance != null ) 
	    throw new RuntimeException("attempt to init me twice");
	instance = new RootNode( s );
	return instance;
    }

    public static RootNode getInstance() {
	if( instance == null ) 
	    throw new RuntimeException("not properly initialized");
	return instance;
    }

    // called by SessionTreeModel
    public RegLangSetNode addRegLangSet( RegLangSet r ) {
	RegLangSetNode rn = new RegLangSetNode( r );
	rsVec.add( rn );
	return rn;
    }
    // called by SessionTreeModel
    public int removeRegLangSetNode( RegLangSetNode rn ) {
	int i = getIndex( rn );
	if (-1 != i) rsVec.removeElementAt( i );
	return i;
    }

    private static RootNode instance = null;

    private RootNode(String s) {
	sessionName = s;
	rootPanel = RootPanel.getInstance();
    }

    public String toString() {
	return sessionName;
    }

    public JPanel getPanel() {
	return rootPanel;
    }

    /** visitor method
     */
    public Object apply(GuiNodeVisitor v) {
	return v.caseRootNode( this );
    }

    public TreePath getPath() {
	return new TreePath( this );
    }


    /** Returns the children of the reciever as an Enumeration. */
    public Enumeration children()       { 
	return rsVec.elements();
    }

    /** Returns true if the receiver allows children. */
    public boolean getAllowsChildren()  {return true; }

    /** Returns the child TreeNode at index childIndex.*/
    public TreeNode getChildAt(int index)  {
	return (TreeNode) rsVec.get(index); 
    }

    /** Returns the number of children TreeNodes the receiver contains. */
    public int getChildCount()              { return rsVec.size();}

    /** Returns the index of node in the receivers children.*/
    public int getIndex(TreeNode node) { 
	RegLangSetNode ln = (RegLangSetNode) node;
	return rsVec.indexOf(ln);
    }

    /** Returns the parent TreeNode of the receiver. */
    public TreeNode getParent() { return null; }

    /** Returns true if the receiver is a leaf. */
    public boolean isLeaf() { return false; }

}
