package net.sourceforge.amore.gui.global ;

import java.lang.Exception ;

/* tool functions. fixme, replaces strings by real classes
 */

public class EditMethods {
    /** these are class names for which an input Method does exist.
     */
    public final static String[] inputClasses = { 
        "net.sourceforge.amore.Ldo.Dfa", 
        "net.sourceforge.amore.Ldo.Nfa", 
        "net.sourceforge.amore.Ldo.RegExp" };

    public static int index( Class clazz ) {
	String s = clazz.getName();
	for(int i=0; i<inputClasses.length ;i++) {
	    if( s.equals(inputClasses[ i ]) )
		return i;
        }
	return -1;
    }

    public static Class getClassByIndex( int index ) {
	try {
	    return Class.forName(inputClasses[ index ]);
	} catch (ClassNotFoundException e) {
	    throw new IllegalArgumentException(" index out of range ");
	}
    }

    /** cuts away the package name from the class name
     */
    private static String suffix(String s) {
	return s.substring( s.lastIndexOf(".") + 1);
    }
    
    public static String getNameTerse( Class clazz ) {
	return suffix( clazz.toString() );
    }

    /** convenience function, cuts away package names.
     */
    public static String[] getInputClassesTerse() {
        int len = inputClasses.length;
        String[] res = new String[ len ];
        
        for(int i=0; i<len; i++) {
            res[ i ]= suffix( inputClasses[ i ] );
        }
        return res;
    }

    
}
