package net.sourceforge.amore.gui.util ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;

/** displays the startup screen
 */

public class StartupWindow extends JWindow implements MouseListener, Runnable {

    /* FIXME */
    final static String imageFile = "amoreTitle.jpg";
    final static int imageHeight = 250;
    final static int imageWidth  = 500;

    public static boolean showWin;

    /* to display the startup image
     */
    static class ImagePanel extends JPanel  {
	Image image;
	public ImagePanel(Image image) {
	    this.image = image;
	}
	public void paintComponent(Graphics g) {
	    super.paintComponent(g); //paint background
	    //Draw image at its natural size first.
	    g.drawImage(image, 0, 0, this); //256x256 image
	}
    }
    
    public void run() {
	int i = 0;
	while (showWin) {
	    try{ 
		Thread.sleep(500);
		/* waits 4 seconds */
		toFront();
		if (i++ == 8) showWin = false;
	    } catch (InterruptedException e) {
		System.out.println( "interrupted!" + e.toString() );
	    }
	}
	setVisible(false);
    }

    protected void finalize() throws Throwable {
	System.out.println("StartupWindow finalized ");
    }
    
    public StartupWindow() {
	super();

	/* shtupid code to load and display image */
	String imageFile=System.getProperty("apphome")+"/bin/amoreTitle.jpg";
	Image image = Toolkit.getDefaultToolkit().createImage(imageFile);
        ImagePanel imagePanel = new ImagePanel(image);
	
	/* FIXME: move image to RESOURCE */

	GraphicsConfiguration gc = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration();
	Rectangle r = gc.getBounds();
	int x = (r.width - imageWidth) / 2;
	int y = (r.height - imageHeight) / 2;
        getContentPane().add(imagePanel, BorderLayout.CENTER);
        //f.setSize(new Dimension(256,256));
	setBounds(x,y, imageWidth,imageHeight);
	addMouseListener( this );
    }

    synchronized public  void mousePressed(MouseEvent e) {
	showWin = false;
    }
    public  void mouseReleased(MouseEvent e) {}
    public  void mouseEntered(MouseEvent e) {}
    public  void mouseExited(MouseEvent e) {}
    public  void mouseClicked(MouseEvent e) {}

    public static void showStartupWindow() {
	
	final StartupWindow w = new StartupWindow();
	showWin = true;
	
        final Thread t = new Thread(w);
	t.start();
	w.setVisible(true);
    }
}
