#include <rexFromString.h>
#include <regexp.h>
#include <nfa2dfa.h>
#include <dfamdfa.h>
#include <print.h>

void usage(char * app_name) {
  printf("usage: %s rex\n\trex - a regular expression\n", app_name);
}

int main(int argc, char ** argv) {
  regex r;
  nfa n;
  dfa d, m;
  int char_count=0, i;
  char previously_found[27] = "abcdefghijklmnopqrstuvwxyz"; // we know that there can only be these chars in the regexp

  if(2 != argc) {
    usage(argv[0]);
    exit(1);
  }

  // Count the number of characters that are not  ( ) ~ + * U . & - ? $
  for(i=0;'\0' != argv[1][i]; i++) {
    int j;
    switch(argv[1][i]) {
    case '(' || ')' || '~' || '+' || '*' || 'U' || '.' || '&' || '-' || '?' || '$':
      break;
    default:
      // Check that we've not previously found this char
      for(j=0;j<27;j++) {
	if(previously_found[j] == argv[1][i]) {
	  printf("found %c", argv[1][i]);
	  previously_found[j] = 1;
	  char_count++;
	}
      }
    }
  }

  r = rexFromString(char_count, argv[1]);
  if(!r) {
    printf("There was an errror with your regular expression\n");
  }

  n = rex2nfa(r);
  d = nfa2dfa(n);
  m = dfamdfa(d, TRUE);

  printDfa(m);

  freenfa(n);
  freedfa(m);
}
