#include "net_sourceforge_amore_Ldo_BinTransforms.h"

#ifdef DEBUG
#include <debugPrint.h>
#endif

#include <nfa.h>
#include <dfa.h>

#include <binary.h>


JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_BinTransforms_prim_1union(JNIEnv *jEnv, jclass clazz, jint p1, jint p2) {
  nfa n1 = (nfa) ((unsigned int) p1);
  nfa n2 = (nfa) ((unsigned int) p2);
  return (jint) unionfa(n1, n2);
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_BinTransforms_prim_1concat(JNIEnv *jEnv, jclass clazz, jint p1, jint p2) {
  nfa n1 = (nfa) ((unsigned int) p1);
  nfa n2 = (nfa) ((unsigned int) p2);
  return (jint) concatfa(n1, n2);
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_BinTransforms_prim_1insec(JNIEnv *jEnv, jclass clazz, jint p1, jint p2) {
  dfa d1 = (dfa) ((unsigned int) p1);
  dfa d2 = (dfa) ((unsigned int) p2);
  return (jint) insecfa( d1, d2, FALSE );
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_BinTransforms_prim_1minus(JNIEnv *jEnv, jclass clazz, jint p1, jint p2) {
  dfa d1 = (dfa) ((unsigned int) p1);
  dfa d2 = (dfa) ((unsigned int) p2);
  return (jint) insecfa( d1, d2, TRUE );
}


JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_BinTransforms_prim_1shuffle(JNIEnv *jEnv, jclass clazz, jint p1, jint p2) {
  nfa n1 = (nfa) ((unsigned int) p1);
  nfa n2 = (nfa) ((unsigned int) p2);
  return (jint) shuffle(n1, n2);
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_BinTransforms_prim_1rightQuot(JNIEnv *jEnv, jclass clazz, jint p1, jint p2) {
  dfa d1 = (dfa) ((unsigned int) p1);
  dfa d2 = (dfa) ((unsigned int) p2);
  return (jint) rightquot(d1, d2);
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_BinTransforms_prim_1leftQuot(JNIEnv *jEnv, jclass clazz, jint p1, jint p2) {
  dfa d1 = (dfa) ((unsigned int) p1);
  dfa d2 = (dfa) ((unsigned int) p2);
  return (jint) leftquot(d1, d2);
}

