#include "net_sourceforge_amore_Ldo_Dfa.h"

#include "dfa.h"

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1construct
(JNIEnv *jEnv, jclass clazz, jint qno, jint sno) {
  
  dfa d = newdfa();

  d->qno = qno;
  d->sno = sno;
  d->final = newfinal( qno );
  d->delta = newddelta( sno, qno );

#ifdef DEBUG    
  printf("dfauto_1construct( %d, %d ) : %d\n", (int) qno, (int)sno, (int)d);
#endif
  fflush(stdout);

  return (jint) d;

}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1clone
    (JNIEnv *jEnv, jclass clazz, jint p) {
    return (jint) clonedfa( (dfa) p );
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1destruct
(JNIEnv *jEnv, jclass clazz, jint p) {
#ifdef DEBUG
  printf("dfauto_1destruct( %d )\n",(int)p);    fflush(stdout);
#endif
  freedfa( (dfa) p );
  dispose( p );
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1connect
(JNIEnv *jEnv, jclass clazz, jint p, jint F, jint L, jint T) {
  
#ifdef DEBUG 
  printf("dfauto_1connect( %d, from %d, letter %d, to %d )\n",(int)p, (int)F,(int) L, (int)T); 
  fflush(stdout);
#endif
  ((dfa) p)->delta[ L ][ F ] = T;
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1disconnect
(JNIEnv *jEnv, jclass clazz, jint p, jint F, jint L) {
  
#ifdef DEBUG 
  printf("dfauto_1disconnect( %d, from %d, letter %d )\n",(int)p, (int)F,(int) L); 
  fflush(stdout);
#endif
  ((dfa) p)->delta[ L ][ F ] = 0;
}


JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1getcon
    (JNIEnv *jEnv, jclass clazz, jint p, jint F, jint L ) {
    return (jint) ((dfa) p)->delta[ L ][ F ];
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1getNletters
  (JNIEnv *jEnv, jclass clazz, jint p) {
    return (jint) ((dfa) p)->sno;
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1getNstates
    (JNIEnv *jEnv, jclass clazz, jint p) {
    return (jint) (((dfa) p)->qno + 1);
}
    
JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1isFinalState
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {
    return (jboolean) isfinal( ((dfa) p)->final[ q ] );
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1getInit
  (JNIEnv *jEnv, jclass clazz, jint p ) {
    return (jint) ((dfa) p)->init;
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1setFinal
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {    
#ifdef DEBUG 
  printf("dfauto_1setFinal( %d, %d )\n", (int)p, (int)q); 
#endif
    setfinalT( ((dfa) p)->final[ q ] );
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1setInit
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {
#ifdef DEBUG 
  printf("dfauto_1setInit( %d, %d )\n",(int) p, (int)q); 
#endif
    ((dfa) p)->init = q;
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1setNonFinal
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {
    setfinalF( ((dfa) p)->final[ q ] );
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1setMin
  (JNIEnv *jEnv, jclass clazz, jint p, jboolean isred) {
#ifdef DEBUG 
  printf("dfauto_1setRed( %d, %d )\n", (int)p, (int)isred); 
#endif
    if( isred ) 
	((dfa) p)->minimal = TRUE;
    else
	((dfa) p)->minimal = FALSE;
}

JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_Ldo_Dfa_dfauto_1isMin
  (JNIEnv *jEnv, jclass clazz, jint p) {
    return (jint) ((dfa) p)->minimal;
}

