#include "net_sourceforge_amore_Ldo_Nfa.h"

#include "nfa.h" /* newnfa(), setfinalF, setfinalT */


// define NFA_METHOD( name ) JNICALL Java_net_sourceforge_amore_Ldo_Nfa_ ## name
// JNIEXPORT jint NFA_METHOD( nfauto1_construct )

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1construct
     (JNIEnv *jEnv, jclass clazz, jint qno, jint sno, jboolean eps) {
  
  nfa n = newnfa();
#ifdef DEBUG
  printf("nfauto_1construct(qno %d sno %d ) : %d\n", (int) qno, (int)sno, (int)n);
#endif

  n->qno = qno;
  n->sno = sno;

  n->infin = newfinal( qno );
#ifdef DEBUG
  printf("  .infin = newfinal( %d ) = %d\n",(int) qno,(int)n->infin);
#endif
  if( eps ) {
      n->delta = newendelta( sno,qno );
#ifdef DEBUG
      printf("  .delta = newendelta(sno %d qno %d) = %d\n",(int) sno, (int) qno,(int)n->delta);
#endif

  } else {
      n->delta = newndelta( sno,qno ); 
#ifdef DEBUG
      printf("  .delta = newndelta(sno %d qno %d) = %d\n",(int) sno, (int) qno,(int)n->delta);
#endif
  }

    fflush(stdout);

  return (jint) n;

}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1destruct
(JNIEnv *jEnv, jclass clazz, jint p) {
#ifdef DEBUG
    printf("nfauto_1destruct( %d )\n", (int) p);
#endif
    freenfa( (nfa) p );
    dispose( p );
}


JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1clone
    (JNIEnv *jEnv, jclass clazz, jint p) {
    return (jint) clonenfa( (nfa) p );
}


JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1connect
(JNIEnv *jEnv, jclass clazz, jint p, jint F, jint L, jint T) {
        
#ifdef DEBUG
    printf("nfauto_1connect( F:%d, L:%d, T:%d )\n", (int)F,(int) L, (int)T);
#endif
    fflush(stdout);
    connect( ((nfa) p)->delta, L, F, T );
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1disconnect
    (JNIEnv *jEnv, jclass clazz, jint p, jint F, jint L, jint T) {
    disconnect( ((nfa) p)->delta, L, F, T );
}

JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1testcon
    (JNIEnv *jEnv, jclass clazz, jint p, jint F, jint L, jint T) {
    return (jboolean) testcon( ((nfa) p)->delta, L, F, T ) ;
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1getNletters
  (JNIEnv *jEnv, jclass clazz, jint p) {
    return (jint) ((nfa) p)->sno;
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1getNstates
    (JNIEnv *jEnv, jclass clazz, jint p) {
    return (jint) (((nfa) p)->qno + 1);
}
    
JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1isFinalState
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {
    return (jboolean) isfinal( ((nfa) p)->infin[ q ] );
}

JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1isInitState
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {
    return (jboolean) isinit( ((nfa) p)->infin[ q ] );
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1setFinal
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {    
#ifdef DEBUG
    printf("nfauto_1setFinal( %d, %d )\n", (int)p, (int)q);
#endif
    setfinalT( ((nfa) p)->infin[ q ] );
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1setInit
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {
#ifdef DEBUG
    printf("nfauto_1setInit( %d, %d )\n", (int)p, (int)q);
#endif
    setinit( ((nfa) p)->infin[ q ] );
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1setNonFinal
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {
    setfinalF( ((nfa) p)->infin[ q ] );
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1setNonInit
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {
    rminit( ((nfa) p)->infin[ q ] ) ;
}


JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1setRed
  (JNIEnv *jEnv, jclass clazz, jint p, jboolean isred) {
#ifdef DEBUG
    printf("nfauto_1setRed( %d, %d )\n", (int)p,(int) isred);
#endif
    if( isred ) 
	((nfa) p)->minimal = TRUE;
    else
	((nfa) p)->minimal = FALSE;
}

JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1isRed
  (JNIEnv *jEnv, jclass clazz, jint p) {
    return (jint) ((nfa) p)->minimal;
}

JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1setEps
  (JNIEnv *jEnv, jclass clazz, jint p, jboolean iseps) {
#ifdef DEBUG
    printf("nfauto_1setEps( %d, %d )\n", (int)p, (int)iseps);
#endif
    if( iseps ) 
	((nfa) p)->is_eps = TRUE;
    else
	((nfa) p)->is_eps = FALSE; 
}

JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_Ldo_Nfa_nfauto_1isEps
    (JNIEnv *jEnv, jclass clazz, jint p) {
    return (jint) ((nfa) p)->is_eps;
}
