#include <jni.h>

#include "net_sourceforge_amore_Ldo_RegExp.h"

#include "regexp.h"

#define JAVAEXCEPT
#include "rexFromString.h"


#include "string.h" /* strdup */

/*
 * Class:     net_sourceforge_amore_Ldo_RegExp
 * Method:    rex_construct
 * Signature: (Ljava/lang/String;I)I
 */
#include "parse.h"

extern PARSE_RESULT errorParseResult;

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_RegExp_rex_1construct
    (JNIEnv *jEnv, jclass clazz, jstring jstr, jint sno) {

    jclass newExcCls = (*jEnv)->FindClass(jEnv, "net/sourceforge/amore/Exceptions/RegExpParseException");
    regex r;
    /* get string representation */
    char *str = strdup( (*jEnv)->GetStringUTFChars(jEnv, jstr, 0) );
    (*jEnv)->ReleaseStringUTFChars(jEnv, jstr, 0);
    
    if (newExcCls == 0) {
	fprintf(stderr, "fatal: unable to find class RegExpParseException");
	return -1;
    }

    /* printf("parsing regex %s",str); */

    /* convert to rex and return (hopefully) */
    r = rexFromString(sno, str );//, jEnv, newExcCls);
    if( r == (regex) 0 ) {
      //printf(errorParseResult->error_message);
      (*jEnv)->ThrowNew(jEnv, newExcCls, errorParseResult->error_message);
    }
    return (jint) r;
}
/*
 * Class:     net_sourceforge_amore_Ldo_RegExp
 * Method:    rex_destruct
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_RegExp_rex_1destruct
    (JNIEnv *jEnv, jclass clazz, jint p) {
    freerex( (regex) p );
    dispose( p );
}

/*
 * Class:     net_sourceforge_amore_Ldo_RegExp
 * Method:    rex_clone
 * Sig        (I)I
 */
JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_RegExp_rex_1clone
    (JNIEnv *jEnv, jclass clazz, jint p) {
    regex res= newrex();
    regex src= (regex) p;
    res->sno = src->sno;
    res->rex = strdup(src->rex);
    res->exprex = strdup(src->exprex);
    res->rexl = src->rexl;
    res->erexl= src->erexl;
    res->grex = src->grex;
    return (jint) res;
}


/*
 * Class:     net_sourceforge_amore_Ldo_RegExp
 * Method:    rex_getExpRex
 * Signature: (I)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_net_sourceforge_amore_Ldo_RegExp_rex_1getExpRex
(JNIEnv *jEnv, jclass clazz, jint p) { 
  string s = ((regex) p)->exprex;
  return (*jEnv)->NewStringUTF(jEnv, s);
}
/*
 * Class:     net_sourceforge_amore_Ldo_RegExp
 * Method:    rex_getNletters
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_RegExp_rex_1getNletters
(JNIEnv *jEnv, jclass clazz, jint p){
  return (jint) ((regex) p )->sno;
}

/*
 * Class:     net_sourceforge_amore_Ldo_RegExp
 * Method:    rex_setNletters
 * Signature: (I)II
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_Ldo_RegExp_rex_1setNletters
(JNIEnv *jEnv, jclass clazz, jint p, jint i){
  ((regex) p )->sno = (posint) i;
}


/*
 * Class:     net_sourceforge_amore_Ldo_RegExp
 * Method:    rex_getRex
 * Signature: (I)Ljava/lang/String{

 */
JNIEXPORT jstring JNICALL Java_net_sourceforge_amore_Ldo_RegExp_rex_1getRex
  (JNIEnv *jEnv, jclass clazz, jint p){
    string s = ((regex) p )->rex ;
    return (*jEnv)->NewStringUTF(jEnv, s); 
}
/*
 * Class:     net_sourceforge_amore_Ldo_RegExp
 * Method:    rex_isGen
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_Ldo_RegExp_rex_1isGen
  (JNIEnv *jEnv, jclass clazz, jint p){
    if (((regex) p )->grex)
	return JNI_TRUE;
    else
	return JNI_FALSE;
}
