#include "net_sourceforge_amore_Ldo_Transforms.h"

#ifdef DEBUG
#include <debugPrint.h>
#endif

/* REGEXP transformations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

#include <genrex2nfa.h> /* ----------------------- GENREGEXP -> NFA ---------*/

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Transforms_prim_1genrex2nfa
 (JNIEnv *jEnv, jclass clazz, jint p) {
    regex r = (regex) ((unsigned int) p);
    nfa n;
#ifdef DEBUG
    printf("[Ldo_Transforms.c] prim_1genrex2nfa( %d )\n",(unsigned int) r);
    debugPrintRegExp( r );
#endif
    n = genrex2nfa( r );
#ifdef DEBUG
    printf("[Ldo_Transforms.c] prim_1genrex2nfa: result is");
    debugPrintNfa(n);
#endif
  return (jint) n;
}

#include <rex2nfa.h> /*  --------------------------- REGEXP -> NFA ---------*/

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Transforms_prim_1rex2nfa
(JNIEnv *jEnv, jclass clazz, jint p) {
    regex r = (regex) ((unsigned int) p);
    nfa n;
#ifdef DEBUG
    printf("[Ldo_Transforms.c] prim_1rex2nfa( %d )\n",(unsigned int) r);
    debugPrintRegExp( r );
#endif
    n = rex2nfa( r );
#ifdef DEBUG
    printf("[Ldo_Transforms.c] prim_1rex2nfa: result is");
    debugPrintNfa(n);
#endif
  return (jint) n;
}

/* NFA transformations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   */

#include <enfa2nfa.h> /* --------------------- ENFA -> NFA -----------------*/

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Transforms_prim_1enfa2nfa
(JNIEnv *jEnv, jclass clazz, jint p ) {
  nfa n = (nfa) ((unsigned int) p);
  nfa n2 = enfa2nfa( n );
  return (jint) n2;
}


#include <nfa2dfa.h> /* ------------------------------- NFA -> DFA ---------*/

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Transforms_prim_1nfa2dfa
(JNIEnv *jEnv, jclass clazz, jint p) {
    nfa n = (nfa) ((unsigned int) p);
    dfa d;
#ifdef DEBUG
    printf("debugprintnfa\n");
    debugPrintNfa( n );
    printf("[Ldo_Transforms.c] prim_1nfa2dfa( %d )\n",(unsigned int) n);
#endif
    d = nfa2dfa( n );
#ifdef DEBUG
    printf("[Ldo_Transforms.c] nfa2dfa: result is");
    debugPrintDfa(d);
#endif
  return (jint) d;
}

#include <nfa2rex.h> /* ---------------------------- NFA -> REGEXP --------- */

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Transforms_prim_1nfa2rex
  (JNIEnv *jEnv, jclass clazz, jint p) {
    nfa n = (nfa) ((unsigned int) p);
    regex r;
#ifdef DEBUG
    printf("[Ldo_Transforms.c] prim_1nfa2rex( %d )\n",(unsigned int) n);
#endif
    r = nfa2rex( n );
    return (jint) r;
}

#include <nfa2mnfa.h> /* --------------------------- NFA -> REDNFA --------- */

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Transforms_prim_1nfa2rednfa
  (JNIEnv *jEnv, jclass clazz, jint p1, jint p2) {
    nfa n = (nfa) ((unsigned int) p1);
    dfa d = (dfa) ((unsigned int) p2);
    nfa redn;
#ifdef DEBUG
    printf("[Ldo_Transforms.c] prim_1nfa2mnfa( %d )\n",(unsigned int) n);
#endif
    redn = nfa2mnfa( n, d );
    redn->minimal = TRUE; /* why is this not set in nfa2mnfa ? */
    return (jint) redn;
}

/* DFA transformation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

#include <dfa2nfa.h> /* ------------------------------- DFA -> NFA ---------*/

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Transforms_prim_1dfa2nfa
  (JNIEnv *jEnv, jclass clazz, jint p) {
    dfa d = (dfa) ((unsigned int) p);
    nfa n;
#ifdef DEBUG
    printf("[Ldo_Transforms.c] prim_1nfa2dfa( %d )\n",(unsigned int) d);
#endif
    n = dfa2nfa( d );
    return (jint) n;
}

#include <dfamdfa.h> /* ------------------------------- DFA -> MinDFA ------*/

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Transforms_prim_1dfa2mindfa
  (JNIEnv *jEnv, jclass clazz, jint p) {
    dfa d = (dfa) ((unsigned int) p);
    dfa mdfa;
#ifdef DEBUG
    printf("[Ldo_Transforms.c] prim_1dfa2mdfa( %d )\n",(unsigned int) d);
#endif
    mdfa = dfamdfa( d, FALSE );
    return (jint) mdfa;
}

#include <dfa2mon.h> /* -------------------------------- DFA -> Monoid -----*/

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_Ldo_Transforms_prim_1dfa2mon
(JNIEnv *jEnv, jclass clazz, jint p) {
  dfa d = (dfa) ((unsigned int) p);
  monoid mon;
#ifdef DEBUG
  printf("[Ldo_Transforms.c] prim_1dfa2mon( %d )\n",(unsigned int) d);
#endif
  mon = dfa2mon( d );
  return (jint) mon;
}
