/* RegLangSet.c
 */

#include "net_sourceforge_amore_RegLangSet.h"

#include "language.h"

#include<string.h> /* strdup */

/*
 * Class:     Ldo_Bundle
 * Method:    regset_construct
 * Signature: ()Ide.rwth_aachen.i7.libAMoRE
 */
JNIEXPORT jint JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1construct
    (JNIEnv *jEnv, jclass clazz) {
#ifdef DEBUG
  printf("regset_1construct(..)\n");
#endif
    return (jint)  newlang();
}

/*
 * Class:     RegLangSet
 * Method:    regset_destruct
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1destruct
    (JNIEnv *jEnv, jclass clazz, jint p) {
    freelang( (language) p );
    dispose( p );
}

/*
 * Class:     RegLangSet
 * Method:    regset_getDescr
 * Signature: (I)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1getDescr
    (JNIEnv *jEnv, jclass clazz, jint p) {
    return (*jEnv)->NewStringUTF(jEnv, ((language) p )->ref);
}

/*
 * Class:     RegLangSet
 * Method:    regset_getName
 * Signature: (I)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1getName
  (JNIEnv *jEnv, jclass clazz, jint p) {
    return (*jEnv)->NewStringUTF(jEnv, ((language) p )->name);
}

/*
 * Class:     RegLangSet
 * Method:    regset_getNletters
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1getNletters
    (JNIEnv *jEnv, jclass clazz, jint p) {
    return (jint) ((language) p )->sizeal;
}

/*
 * Class:     RegLangSet
 * Method:    regset_setNletters
 * Signature: (II)I ??? glaub schon.
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1setNletters
    (JNIEnv *jEnv, jclass clazz, jint p, jint sno) {
    ((language) p )->sizeal = sno;
}


/*
 * Class:     RegLangSet
 * Method:    regset_setDescr
 * Signature: (ILjava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1setDescr
    (JNIEnv *jEnv, jclass clazz, jint p, jstring jstr) {
    const char *s = (*jEnv)->GetStringUTFChars(jEnv, jstr, 0);
    char **ref = &(((language) p )->ref);

    if( *ref )
	dispose( *ref );
    /* duplicate String */
    *ref = strdup( s );
    (*jEnv)->ReleaseStringUTFChars(jEnv, jstr, s);
    return;
}

/*
 * Class:     RegLangSet
 * Method:    regset_setName
 * Signature: (ILjava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1setName
  (JNIEnv *jEnv, jclass clazz, jint p, jstring jstr) {
    const char *s = (*jEnv)->GetStringUTFChars(jEnv, jstr, 0);
    char **name = &(((language) p )->name);

    if( *name )
	dispose( *name );
    /* duplicate String */
    *name = strdup( s );

    (*jEnv)->ReleaseStringUTFChars(jEnv, jstr, s);
    return;
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1get_1maxlength_1name(JNIEnv *ignore1, jclass ignore2) {
  return NLEN;
}

JNIEXPORT jint JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1get_1maxlength_1descr(JNIEnv *ignore1, jclass ignore2) {
  return REFLEN;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_setInputNfa
 * Signature: (II)Z
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1setInputNfa
(JNIEnv *jEnv, jclass clazz, jint p, jint q) {
  language lan = (language) ((unsigned int) p);
  nfa n = (nfa) ((unsigned int) q);
  if( n->is_eps ) {
    lan->inputis = OENFAINP; //  enfa
    lan->oenfa = n;
  } else {
      lan->inputis = NFAINP; //  nfa
      lan->lnfa = n;
      lan->bnfa = TRUE;
  }
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_setInputDfa
 * Signature: (II)Z
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1setInputDfa
(JNIEnv *jEnv, jclass clazz, jint p, jint q) {
   language lan = (language) ((unsigned int) p);
  dfa d = (dfa) ((unsigned int) q);

  lan->inputis = DFAINP; //  dfa
  lan->ldfa = d; 
  lan->bdfa = TRUE;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_setInputRegExp
 * Signature: (II)Z
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1setInputRegExp
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {
  language lan = (language) ((unsigned int) p);
  regex r = (regex) ((unsigned int) q);

  lan->inputis = REXINP; //  rex
  lan->lrex = r; 
  lan->brex = TRUE;
}


/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_getInputIs
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1getInputIs
  (JNIEnv *jEnv, jclass clazz, jint p) {
  language lan = (language) ((unsigned int) p);
  return (jint) lan->inputis;
}


/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_addNfa
 * Signature: (II)Z
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1addNfa
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {
  language lan = (language) ((unsigned int) p);
  nfa n = (nfa) ((unsigned int) q);  
  
  lan->lnfa = n;
  lan->bnfa = TRUE;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_addRedNfa
 * Signature: (II)Z
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1addRedNfa
  (JNIEnv *jEnv, jclass clazz, jint p, jint q) {
  language lan = (language) ((unsigned int) p);
  nfa n = (nfa) ((unsigned int) q);  
  /* ? */
  if (lan->inputis == NFAINP) { 
    lan->inputis = ONFAINP; 
    lan->onfa = lan->lnfa;
  }
  lan->lnfa = n;
  lan->bnfa = TRUE;
}
/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_addDfa
 * Signature: (II)Z
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1addDfa
(JNIEnv *jEnv, jclass clazz, jint p, jint q) {
  language lan = (language) ((unsigned int) p);
  dfa d = (dfa) ((unsigned int) q);
  
  lan->ldfa = d;
  lan->bdfa = TRUE;
}
/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_addMinDfa
 * Signature: (II)Z
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1addMinDfa
(JNIEnv *jEnv, jclass clazz, jint p, jint q) {
  language lan = (language) ((unsigned int) p);
  dfa d = (dfa) ((unsigned int) q);
  if (lan->inputis == DFAINP) {
    lan->odfa = lan->ldfa;
    lan->inputis = ODFAINP;
  }
  lan->ldfa = d;
  lan->bdfa = TRUE;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_addRegExp
 * Signature: (II)Z
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1addRegExp
(JNIEnv *jEnv, jclass clazz, jint p, jint q) {
  language lan = (language) ((unsigned int) p);
  regex r = (regex) ((unsigned int) q);
  
  lan->lrex = r;
  lan->brex = TRUE;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_addRegExp
 * Signature: (II)Z
 */
JNIEXPORT void JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1addMonoid
(JNIEnv *jEnv, jclass clazz, jint p, jint q) {
  language lan = (language) ((unsigned int) p);
  monoid m = (monoid) ((unsigned int) q);
  
  lan->lmon = m;
  lan->bmon = TRUE;
}

#include <fileIO.h>

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_save
 */
JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1save
(JNIEnv *jEnv, jclass clazz, jint p, jstring jstr) {
  language lan = (language) ((unsigned int) p);
  char *str = strdup( (*jEnv)->GetStringUTFChars(jEnv, jstr, 0) );
  (*jEnv)->ReleaseStringUTFChars(jEnv, jstr, 0);
  if( writelan(lan, str) )
    return TRUE;
  else
    return FALSE;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_load
 */
JNIEXPORT jint JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1load
(JNIEnv *jEnv, jclass clazz, jstring nam, jstring dir) {
  char *namstr = strdup( (*jEnv)->GetStringUTFChars(jEnv, nam, 0) );
  char *dirstr = strdup( (*jEnv)->GetStringUTFChars(jEnv, dir, 0) );

  (*jEnv)->ReleaseStringUTFChars(jEnv, nam, 0);
  (*jEnv)->ReleaseStringUTFChars(jEnv, dir, 0);

  return (jint) rdinlan(namstr, dirstr);
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_get_brex
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1get_1brex
(JNIEnv *jEnv, jclass clazz, jint p) {
  language lan = (language) ((unsigned int) p);
  return (jboolean) lan->brex;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_get_bdfa
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1get_1bdfa
(JNIEnv *jEnv, jclass clazz, jint p) {
  language lan = (language) ((unsigned int) p);
  return (jboolean) lan->bdfa;
}


/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_get_bnfa
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1get_1bnfa
(JNIEnv *jEnv, jclass clazz, jint p) {
  language lan = (language) ((unsigned int) p);
  return (jboolean) lan->bnfa;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_get_bnfa
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1get_1bmon
(JNIEnv *jEnv, jclass clazz, jint p) {
  language lan = (language) ((unsigned int) p);
  return (jboolean) lan->bmon;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_get_lrex
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1get_1lrex
(JNIEnv *jEnv, jclass clazz, jint p) {
  language lan = (language) ((unsigned int) p);
  return (jint) lan->lrex;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_get_ldfa
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1get_1ldfa
(JNIEnv *jEnv, jclass clazz, jint p) {
  language lan = (language) ((unsigned int) p);
  return (jint) lan->ldfa;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_get_lnfa
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1get_1lnfa
(JNIEnv *jEnv, jclass clazz, jint p) {
  language lan = (language) ((unsigned int) p);
  return (jint) lan->lnfa;
}

/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_get_lnfa
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1get_1lmon
(JNIEnv *jEnv, jclass clazz, jint p) {
  language lan = (language) ((unsigned int) p);
  return (jint) lan->lmon;
}


/*
 * Class:     net_sourceforge_amore_RegLangSet
 * Method:    regset_getInput
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_net_sourceforge_amore_RegLangSet_regset_1getInput
(JNIEnv *jEnv, jclass clazz, jint p) {
  language lan = (language) ((unsigned int) p);
  switch(lan->inputis) {
  case REXINP:
    return (jint) lan->lrex;
  case DFAINP:
    return (jint) lan->ldfa;
  case NFAINP:
    return (jint) lan->lnfa;
  case OREXINP:
    return (jint) lan->orex;
  case ODFAINP:
    return (jint) lan->odfa;
  case ONFAINP:
    return (jint) lan->onfa;
  case OENFAINP:
    return (jint) lan->oenfa;
  }
  return (jint) 0; // this never happens
}

