/* comp.c
 */
#include "comp.h"

#include "liberror.h"

#include "nfa2dfa.h"

task compObjFromObj(objType dest, objType arg, int obj ) {
    return compObjFromObjSpec(0, dest, arg, obj);
}


task compObjFromObjSpec(char timedfreed, objType dest, objType arg, int obj ) {
    const char *errf = "comp.h:compObjFromObjSpec";
    task t;

    if( timedfreed & COMP_TIMED ) {
	printf("TIMED!\n");
    }
    if( timedfreed & COMP_FREED ) {
	printf("FREED!\n");
    }

    switch(dest) {
    case Dfa: 
	/* needs NFA */
	if(!( arg == Nfa )) {
	    liberror(errf, "arg not NFA!"); /* FIXME  */
	} else {
	    t = maketask( (int(*)(int)) nfa2dfa ) ;
	}
	return t;
	break;
    case MinDfa:
	/* needs DFA */
	break;
    case Nfa:
	/* needs one of DFA, ENFA, REX, GenREX */

	break;
    case RedNfa: 
	/* needs MinDfa */

	break;
    case EpsNfa:
	/* does not make sense */
	break;
    case GenRegExp:
	/* error, not possible */
	liberror(errf, "argument GenRegExp not possible");
    case RegExp:
	/* needs Nfa */
    case Mon:
	/* needs MinDfa */
    case SfExp:
	/* needs Mon and test if lan is starfree */
    case Dcl:
	/* needs Mon */
	break;
    }

    return NULL;
}
