#ifndef _COMP_H
#define _COMP_H

/* comp.h
 */
#define COMP_TIMED 0x01
#define COMP_FREED 0x02

#include "obj.h"
#include "task.h"
#include "language.h"

/** returns a task that, when exected, computes an obj from an obj
 *  frees all intermediate objects, no timing. 
 *  please cast obj to int before calling and be sure to give correct type
 *  same as compObjFromObjSpec(0, ...
 */
task compObjFromObj(objType dest, objType arg, int obj ) ;

/** returns a task that, when exected, computes an obj from an obj
 *  please cast obj to int before calling and be sure to give correct type
 */
task compObjFromObjSpec(char timedfreed, objType dest, objType arg, int obj ) ;


/** returns a task that, when executed, computes an obj from objs 
 *   in a language
 */
/* task compObjFromLan(objType dest, language lan) ;
 */

#endif
