/* jfieldIDs.c
 */

#include "jfieldIDs.h"

static jclass   LDO_clazz;
static jfieldID LDO_pID;

static jclass   Com_clazz;
static jfieldID Com_ArgID;
static jfieldID Com_ResID;


int getNativePointer(JNIEnv *jEnv, jobject ldo) {
    /* cast from jint */
    return (int) (*jEnv)->GetIntField(jEnv, ldo, LDO_pID);
};

int command_getArgPointer(JNIEnv *jEnv, jobject cobj) {
    jobject ldo;

    
#ifdef DEBUG
    printf("BEFORE GetObjField, cobj=%d Com_ArgID%d\n",(int)cobj, (int) Com_ArgID);
#endif
    ldo = (*jEnv)->GetObjectField(jEnv, cobj, Com_ArgID);
    if( ldo == NULL ) {
	return 0;
    }
    return getNativePointer(jEnv, ldo);
}

/* this function acts like a LDO-Factory! */

int command_setResPointer(JNIEnv *jEnv, jobject cobj, jint i) {
    /* allocate the LangDefObj */
    jobject obj = (*jEnv)->AllocObject(jEnv, LDO_clazz);
    /* set the pointer */
    (*jEnv)->SetIntField(jEnv, obj, LDO_pID, i);
    /* LdoFactory should produce "right" wrapper from this */
    return i;
}


int jfieldIDs_init(JNIEnv *jEnv) {
    jclass clazz;
#ifdef DEBUG
    printf("[jfieldIDs_init:]\n");
#endif
    /* init structure:    nfaField */
    if(!( clazz = (*jEnv)->FindClass(jEnv, "Ldo/LangDefObj") )) 
	return JNI_FALSE; /* error, clazz not found */
#ifdef DEBUG
    printf("[got class Ldo/LangDefObj]\n");
#endif

    LDO_clazz = (*jEnv)->NewGlobalRef(jEnv, clazz);

    if(!( LDO_pID = (*jEnv)->GetFieldID(jEnv, LDO_clazz, "p","I") ))
	return JNI_FALSE; /* error, fid not found */

#ifdef DEBUG
    printf("[got ID p");
#endif

    if(!( clazz = (*jEnv)->FindClass(jEnv, "Command/Command")))
	return JNI_FALSE; 

#ifdef DEBUG
    printf("[got class Command/Command");
#endif

    Com_clazz = (*jEnv)->NewGlobalRef(jEnv, clazz);
    
    if(!( Com_ArgID = (*jEnv)->GetFieldID(jEnv, Com_clazz, "arg","LLdo/LangDefObj;") ))
	return JNI_FALSE; /* error, fid not found */

#ifdef DEBUG
    printf("[got ID arg]");
#endif   

    if(!( Com_ResID = (*jEnv)->GetFieldID(jEnv, Com_clazz, "res","LLdo/LangDefObj;") ))
	return JNI_FALSE; /* error, fid not found */

    return JNI_TRUE;
}
