/* obj.c
 */
#include "obj.h"
#include "liberror.h"

void freeObj(objType objT, int obj) {
    const char *errf = "freeObj";
    switch(objT) {
    case Dfa: 
    case MinDfa:
	freedfa( (dfa) obj );
	break;
    case Nfa:
    case RedNfa: 
    case EpsNfa:
	freenfa( (nfa) obj );
	break;
    case GenRegExp:
    case RegExp:
	freerex( (regex) obj );
	break;
    case Mon:
	freemon( (monoid) obj );
	break;
    case SfExp:
	/* you need mno from Mon structure */
	liberror(errf, "arg SfExp not supported...");
	break;
    case Dcl:
	/* you need mno from Mon structure */
	liberror(errf, "arg SfExp not supported...");
	break;
    }
    dispose(obj);
}
