#include "task.h"
#include<malloc.h> /* malloc, FIXME: buffer... */

task maketask(int (*func)(int)) {
    task t = (task) malloc( sizeof(struct task_struct) );
    t->next = NULL;
    t->res  = 0;
    t->func = func;
    return t;
}

void task_freeresults(task t) {
    if( t == NULL ) 
	return;
    while ( t->next != NULL ) {
	freeObj(t->resType, t->res);
	t = t->next;
    }
}

void task_append( task t1, task t2) { 
    t1->next = t2; 
}

int task_getRes( task t ) { 
    return t->res;
}

void task_execAll(task t, int firstArg) {

    int *buf = &firstArg;
    do {
	t->res = t->func( *buf );   /* execute     */
	t->time_used = -1; 	    /* no time check */

	buf = &t->res; 	/* bind result */
	t = t->next;
    } while ( t != NULL );
}

void task_execAllTimed(task t, int firstArg) {

    int *buf = &firstArg;
    clock_start();
    do {
	t->res = t->func( *buf );       /* execute     */
	t->time_used = clock_getTime();	/* check time  */

	buf = &t->res; 	/* bind result */
	t = t->next;
    } while ( t != NULL );
}
