/* BinTransforms.java
 */

package net.sourceforge.amore.Ldo ;

final public class BinTransforms {
    
    /** computes the union L(na1)+L(na2)
     * alphabets need to be the same.
     * RETURN a nfa 
     * @ingroup TRANSF_BINARY
     */
    public static Nfa unionNfa (Nfa n1, Nfa n2) {
        return new Nfa( prim_union( n1.p, n2.p ));
    }
    private static native int prim_union( int p1, int p2 );

    /** computes the concatenation L(na1).L(na2)
     * alphabets need to be the same.
     * RETURN a nfa describing the new language
     * @ingroup TRANSF_BINARY
     */
    public static Nfa concatNfa (Nfa n1, Nfa n2) {
        return new Nfa( prim_concat( n1.p, n2.p ));
    }
    private static native int prim_concat( int p1, int p2 );


    /** computes L(da1) & L(da2) 
     * alphabets need to be the same.
     * @ingroup TRANSF_BINARY
     */
    public static Dfa insecDfa (Dfa d1, Dfa d2) {
        return new Dfa( prim_insec( d1.p, d2.p ));
    }
    private static native int prim_insec( int p1, int p2 );

    /** computes L(da1) \ L(da2)
     * alphabets need to be the same.
     * @ingroup TRANSF_BINARY
     */
    public static Dfa minusDfa (Dfa d1, Dfa d2) {
        return new Dfa( prim_minus( d1.p, d2.p ));
    }
    private static native int prim_minus( int p1, int p2 );

    /** compute the shuffle of na1 and na2 
     * alphabets need to be the same.
     * compute a nfa for the shuffle 
     * @ingroup TRANSF_BINARY
     */ 
    public static Nfa shuffleNfa (Nfa n1, Nfa n2) {
        return new Nfa( prim_shuffle( n1.p, n2.p ));
    }
    private static native int prim_shuffle( int p1, int p2 );

    /** L(rightquot(dfa1,dfa2)) = { w | ex. v in L(dfa2) wv in L(dfa1)  }.
     * alphabets need to be the same.
     * @ingroup TRANSF_BINARY
     */
    public static Dfa rightQuot (Dfa d1, Dfa d2) {
        return new Dfa( prim_rightquot( d1.p, d2.p ));
    }
    private static native int prim_rightquot( int p1, int p2 );
    
    /* L(leftquot(dfa1,dfa2)) = { w | ex. v in L(dfa2) vw in L(dfa1) }.
     * alphabets need to be the same.
     * output is a nfa with usualy more than one initial state .
     * @ingroup TRANSF_BINARY
     */
    public static Dfa leftQuot (Dfa d1, Dfa d2) {
        return new Dfa( prim_rightquot( d1.p, d2.p ));
    }
    private static native int prim_leftquot( int p1, int p2 );
    
}

    
