/** \file DebugPrintVisitor
 */

package net.sourceforge.amore.Ldo ;

/** returns String representation of this Nfa
 */

public class DebugPrintVisitor implements LangDefObjVisitor {
    
    private native static void printNfa( int p ) ;
    private native static void printDfa( int p ) ;
    /** the visited object is an Nfa
     */
    public Object caseNfa( Nfa n ) {
      System.err.println("<-- Nfa ["+ n.toString() +"]\t" +
			 "pointer p: " + n.p + " containing ");
      printNfa( n.p );
      System.err.println("-->");
      return null;
    }
    
    
    /** the visited object is an Dfa
     */
    public Object caseDfa( Dfa d ) {
      System.err.println("<-- Dfa ["+ d.toString() +"]\t" +
	      "pointer p: " + d.p + " containing ");
      printDfa( d.p );
      System.err.println("-->");      
      return null;
    }
    
    /** the visited object is a RegExp
     */
    public Object caseRegExp( RegExp r ) {
        return ("<-- RegExp ["+ r.toString() +"]\t" +
		"pointer p: " + r.p + "-->\n");
    }

    /** the visited object is a Monoid
     */
    public Object caseMonoid( Monoid m ) {
        return ("<-- Monoid ["+ m.toString() +"]\t" +
		"pointer p: " + m.p + "-->\n");
    }


    // Singleton

    private static DebugPrintVisitor instance;

    private DebugPrintVisitor() {
        super();
    }

    public static DebugPrintVisitor getInstance() {
        if (instance == null)
            instance = new DebugPrintVisitor();
        return instance;
    }

    /** convenience function. applies this visitor
     */
    public static String apply(LangDefObj o) {
        return (String) o.apply( getInstance() );
    }
}
