package net.sourceforge.amore.Ldo ;

/** this abstract class contains all the methods that are common to
 *  Nfa and Dfa objects.
 */
public abstract class FiniteAutom extends LangDefObj {

    // ------ constructors

    /** construct a FiniteAutom with a pointer to a C data structure
     */
    protected FiniteAutom( int p ) {
	super( p );
    }


    // ----------------------------------                 methods for #states

    /** returns number of states */
    public abstract int getNstates() ; 

    // ---------------------------------    methods for final/nonfinal states


    /** mark a state as final state */ 
    public abstract void setFinal( int q ) ;

    /** mark a state as nonfinal state */
    public abstract void setNonFinal( int q ) ;

    /** returns true if state q is a final state. */
    public abstract boolean isFinalState( int q ) ;

    // ----------------------------------           methods for initial state

    /** mark a state as an initial state */
    public abstract void setInit( int q ) ;

    
    /** returns true if state q is an/the initial state */
    public abstract boolean isInitState( int q ) ;
    
    // -------------------------------------          methods for transitions
    
    /** make transition from state F to state T with Letter L */
    public abstract void connect( int F, int L, int T ) ;

}
