/* \file LangDefObjVisitor.java
 *
 * defines interface for LangDefVisitable objects
 *
 * May 2001 Burak Emir
 */

package net.sourceforge.amore.Ldo ;

/** interface for LangDefVisitable objects.
 *  every object whose class is a subclass of LangDefObj may be visited by a 
 *  LangDefObjVisitor
 *  
 *  see Gamma et al:"Design Patterns" for an explanation of the visitor pattern
 */

public interface LangDefObjVisitor {

    /** the visited object is an Nfa
     */
    public Object caseNfa( Nfa n );

    /** the visited object is an Dfa
     */
    public Object caseDfa( Dfa d );

    /** the visited object is a RegExp
     */
    public Object caseRegExp( RegExp r );

    /** the visited object is a monoid
     */
    public Object caseMonoid( Monoid m );
}

