/* Monoid. java
 *
 * Aug. 2001 Burak Emir
 */

package net.sourceforge.amore.Ldo;

public class Monoid extends LangDefObj {

    // no constructor ... can only be constructed from transformation
    static native private void mono_destruct( int p );
    
    static native private int  mono_getNletters( int p ) ;
    static native private int  mono_getNstates( int p ) ;
    static native private int  mono_getNelements( int p ) ;
    static native private int  mono_getNgenerators( int p ) ;
    //static native private int  mono_getGenerator( int p, int i ) ;
    static native private int  mono_getNo2Trans( int p, int i, int j ) ;
    static native private String mono_getPrWord( int p, int i );
    
    /** construct with pointer to C-level monoid.
     */
    public Monoid( int p ) {
	super( p );
    }    

    /** returns Monoid
     */
    public String prefix() {
	return "Monoid";
    }

    /** not implemented
     */
    public Object clone() {
        throw new RuntimeException("not implemented!");
    }

    /** destructor method. This method ensures, that when this object
     *  is deleted, the underlying mono is deleted, too */
    protected void finalize() throws Throwable {
	mono_destruct( p );
	super.finalize();
    }
    
    /** #states */
    public int getNstates() {
	return mono_getNstates( p ); // qno + 1
    }
    /** #letters */
    public int getNletters() {
	return mono_getNletters( p ); // sno
    }
    /** #elements */
    public int getNelements() {
	return mono_getNelements( p ); // mno
    }
    /** #generators */
    public int getNgenerators() {
	return mono_getNgenerators( p ); // gno
    }

    /*
      public String getGenerator( int i ) {
      return mono_getGenerator( p, i );
      }
    */
    
    /** returns string containing ?prWord?. needed to display monoid
     */
    public String getPrWord(int i) {
	return mono_getPrWord( p, i );
    }
    
    /** returns number ?no2trans?. needed to display the monoid
     */
    public int getNo2Trans( int i, int j ) {
	return mono_getNo2Trans( p, i, j );
    }
    
    /** calls the caseMonoid method of the visitor.
     */
    public Object apply( LangDefObjVisitor v ) {
	return v.caseMonoid( this );
    }


}
