/* Transforms.class
 * 07 - 2001 Burak Emir
 * wrappers around (primitive) transforms
 */

package net.sourceforge.amore.Ldo ;


/** language preserving transforms between representations.
 *  contains only static methods.
 */

final public class Transforms {
    //
    // RegExp
    //
    private static native int prim_genrex2nfa(int p);
    public static Nfa genrex2nfa(RegExp r) {
	return new Nfa(prim_genrex2nfa(r.p));
    }
    private static native int prim_rex2nfa(int p);
    public static Nfa rex2nfa(RegExp r) {
	return new Nfa(prim_rex2nfa(r.p));
    }
    //
    // Nfa
    //
    private static native int prim_enfa2nfa(int p);
    public static Nfa enfa2nfa(Nfa n) {
	return new Nfa(prim_enfa2nfa( n.p ));
    }
    private static native int prim_nfa2dfa(int p);
    public static Dfa nfa2dfa(Nfa n) {
        return new Dfa( prim_nfa2dfa( n.p ));
    }
    private static native int prim_nfa2rex(int p);
    public static RegExp nfa2rex(Nfa n) {
        return new RegExp( prim_nfa2rex( n.p ));
    }
    private static native int prim_nfa2rednfa(int p1, int p2);
    public static Nfa nfa2rednfa(Nfa n, Dfa d) {
        return new Nfa( prim_nfa2rednfa( n.p, d.p ));
    }
    //
    // Dfa
    //
    private static native int prim_dfa2nfa(int p);
    public static Nfa dfa2nfa(Dfa d) {
	return new Nfa(prim_dfa2nfa( d.p ));
    }
    private static native int prim_dfa2mindfa(int p);
    public static Dfa dfa2mindfa(Dfa d) {
	return new Dfa(prim_dfa2mindfa( d.p ));
    }
    private static native int prim_dfa2mon(int p);
    public static Monoid dfa2mon(Dfa d) {
	return new Monoid(prim_dfa2mon( d.p ));
    }
    
    /** prevent instantiations of this class
     */
    private Transforms() {}
}
