#include "testsfx.h"

void test_star_free_rex_from_rex(void) {
  char * rex = "(ab)*U(ba)*";
  regex r = rexFromString(2, rex);

  nfa n = rex2nfa(r);
  dfa d = nfa2dfa(n);
  dfa m = dfamdfa(d, TRUE);

  monoid mon = dfa2mon(m);

  starfexp s = mon2sfx(m, mon);

  CU_ASSERT(TRUE == s);

  freerex(r);
  freenfa(n);
  freedfa(m);
}

void test_star_free_rex_from_complex_rex(void) {
  char * rex = "c*ac*bc*Uc*bc*ac*";
  regex r = rexFromString(3, rex);

  nfa n = rex2nfa(r);
  dfa d = nfa2dfa(n);
  dfa m = dfamdfa(d, TRUE);

  monoid mon = dfa2mon(m);

  starfexp s = mon2sfx(m, mon);

  //  CU_ASSERT(TRUE == mon->mequals);

  freerex(r);
  freenfa(n);
  freedfa(m);
}
